   -- ,   
   --     n
   ------------------------------
   add:: Int -> [Int] -> [Int]
   add n []     = []
   add n (x:xs) = (x+n) : add n xs
   --------------------------------------------------
   --     
   --  map
   --------------------------
   f1:: Int -> [Int] -> [Int]
   f1 n lst = map (+ n) lst
   ----------------------------------------------------
   -- ,    map  -
   --      
   --  
   ---------------------------
   f2:: [Integer] -> [Integer]
   f2 lst = map (fact) lst
       where  fact n | n==0 = 1
                     | True = n*fact (n-1)
   -- ************************************
   --   :
   ----------------------------------------
   test1 =   add 2 []                 == [] 
          && add 2 [1]                == [3]
          && add (-1) [-2,-1,0,2,3,4] == [-3,-2,-1,1,2,3]
          && add (-5) [-10,0,105]     == [-15,-5,100]
          -------------------------------------------
          && f1 2 []                  == []               
          && f1 2 [1]                 == [3]             
          && f1 (-1) [-2,-1,0,2,3,4]  == [-3,-2,-1,1,2,3]
          && f1 (-5) [-10,0,105]      == [-15,-5,100]
   --------------------------------------------------
   test2 = f2 [1..5] == [1,2,6,24,120]
